org.apache.sysds.runtime.compress.utils

## Class Bitmap

- java.lang.Object
- - org.apache.sysds.runtime.compress.utils.ABitmap
  - - org.apache.sysds.runtime.compress.utils.Bitmap

    public final class Bitmap
    extends ABitmap

Uncompressed representation of one or more columns in bitmap format.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.utils.ABitmap

`ABitmap.BitmapType`

### Constructor Summary

Constructors
Constructor and Description
`Bitmap(IntArrayList[] offsetsLists, double[] values, int rows)`

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `getNumNonZerosInOffset(int idx)`
`int` `getNumValues()` Obtain number of distinct value groups in the column.
`ABitmap.BitmapType` `getType()`
`double[]` `getValues()` Get all values without unnecessary allocations and copies.
`boolean` `lossy()`
`void` `sortValuesByFrequency()`
`String` `toString()`

### Methods inherited from class org.apache.sysds.runtime.compress.utils.ABitmap

`containsZero, getNumColumns, getNumOffsets, getNumOffsets, getNumRows, getOffsetList, getOffsetsList, getZeroCounts, isEmpty`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Bitmap

    public Bitmap(IntArrayList[] offsetsLists,
                  double[] values,
                  int rows)

### Method Detail

#### getValues

    public double[] getValues()

Get all values without unnecessary allocations and copies.

Returns:
  dictionary of value tuples

#### getNumNonZerosInOffset

    public int getNumNonZerosInOffset(int idx)

Specified by:
  `getNumNonZerosInOffset` in class `ABitmap`

#### getNumValues

    public int getNumValues()

Description copied from class: `ABitmap`
Obtain number of distinct value groups in the column. this number is also the number of bitmaps, since there is one bitmap per value

Specified by:
  `getNumValues` in class `ABitmap`
Returns:
  number of distinct value groups in the column;

#### sortValuesByFrequency

    public void sortValuesByFrequency()

Specified by:
  `sortValuesByFrequency` in class `ABitmap`

#### toString

    public String toString()

Overrides:
  `toString` in class `ABitmap`

#### getType

    public ABitmap.BitmapType getType()

Specified by:
  `getType` in class `ABitmap`

#### lossy

    public boolean lossy()

Specified by:
  `lossy` in class `ABitmap`